#!/bin/bash

TEMPRPMFILE=/tmp/rpmqa.$$.system_config
TEMPLSMODFILE=/tmp/lsmod.$$.system_config
TEMPLSPCIFILE=/tmp/lspci.$$.system_config
#TEMPSUIDFILE=/tmp/suid.$$.system_config
TEMPLSCPUFILE=/tmp/lscpu.$$.system_config

#rpm -qa | sort > $TEMPRPMFILE 2>/dev/null
lsmod > $TEMPLSMODFILE
lspci > $TEMPLSPCIFILE
lscpu > $TEMPLSCPUFILE

#entryisinfile(){
#    local __resultvar=$1
#    local myresult=1
#    myresult=`cat $2 | grep -E "$3"`
#    if [ ! -z "$myresult" ];then
#        eval $__resultvar="'1'"
#    else
#        eval $__resultvar="'0'"
#    fi
#}

CPUMHZ=`cat $TEMPLSCPUFILE | grep -m1 -E "^CPU MHz"`
CPUs=`cat $TEMPLSCPUFILE | grep -E "^CPU\("`
Threads=`cat $TEMPLSCPUFILE | grep -E "^Thread"`
Cores=`cat $TEMPLSCPUFILE | grep -E "^Core"`
Memory=`cat /proc/meminfo | grep -E "^MemT"`
Kernel="Kernel: `uname -r`"
#CounterTimer=`cat $TEMPLSMODFILE | grep -E "^ct9513"`
Intel=`cat $TEMPLSMODFILE | grep -E "^i915"`
NVidia=`cat $TEMPLSMODFILE | grep -E "^nvidia"`
pcie=`cat /boot/grub/grub.conf | grep -E "pcie_aspm"`
Model=`cat $TEMPLSCPUFILE | grep -m1 -E "^Model:"`
VendorID=`cat $TEMPLSCPUFILE | grep -m1 -E "^Vendor ID"`
CyflexVer=`ls -l /cyflex | sed 's/^.*cyflex/cyflex/'`
#Cyflex61=`cat $TEMPRPMFILE | grep -E "cyflex-6.1-orig-upgrade"`
#Cyflex62=`cat $TEMPRPMFILE | grep -E "cyflex-6.2-upgrade"`

if [ -z "$pcie" ];then
    pcie_status="pcie_aspm not referenced"
else
    if [[ $pcie == *"pcie_aspm=off"* ]];then
        pcie_status="pcie_aspm=off"
    else
        pcie_status="pcie_aspm=on"
    fi
fi

if [ ! -z "$NVidia" ];then
    NVidiaDriver=`cat /proc/driver/nvidia/version | sed 's/.*Module//'` # | grep -o '^\S*'`
    NVidiaDriver=`echo $NVidiaDriver | grep -o '^\S*'`
    Graphics="Graphics: $NVidia Driver: $NVidiaDriver"
else [ ! -z "$Intel" ]
    Graphics="Graphics: Intel i915"
fi

#if [ -z "$CounterTimer" ];then
#    CounterTimer="Counter Timer not installed"
#fi

if [ -z "$ModelName" ];then
    ModelName="Model name: "
fi

#if [ -z "$Cyflex62" ];then
#    if [ -z "$Cyflex61" ];then
#            CyflexRPMs="6.1-orig and 6.2 not installed"
#    else
#        CyflexRPMs="$Cyflex61 $Cyflex62"
#    fi
#else
#    CyflexRPMs="$Cyflex61 $Cyflex62"
#fi
CyflexRPMs=" "

HardwareConf="$VendorID $Model $CPUMHZ $CPUs $Threads $Cores $Graphics $pcie_status"
HardwareConf=`echo $HardwareConf | awk '$1=$1'`

#echo -e "$HardwareConf"

cyflexlogevent -t machineconfig -m "$HardwareConf" -m "$Kernel" -m "$CyflexRPMs"  -m "$CyflexVer" -m "$Memory"

#echo -e $NVidiaDriver
#echo -e $CyflexRPMs
#echo -e $HardwareConf
#echo -e $VendorID $Model $ModelName $CPUs $Threads $Cores $Graphics $pcie_status
#echo -e $CPUMHZ
#echo -e $VendorID
#echo -e $Model
#echo -e $ModelName
#echo -e $CPUs
#echo -e $Threads
#echo -e $Cores
#echo -e $Memory
#echo -e $Kernel
#echo -e $CounterTimer
#echo -e $Graphics
#echo -e $pcie_status
#echo -e $CyflexVer

for fil in "$TEMPRPMFILE" "$TEMPLSMODFILE" "$TEMPLSPCIFILE" "$TEMPSUIDFILE" "$TEMPLSCPUFILE";do
    if [ -e "$fil" ];then
        rm -f "$fil" > /dev/null 2>/dev/null
    fi
done
